Overview | Package | Class | Tree | Deprecated | Index | Help
| SolarMetric Kodo JDO 2.5.0 Reverse Schema Tool
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## com.solarmetric.rd.kodo.runtime
Interface StoreManager

All Known Implementing Classes:
  DelegatingStoreManager, JDBCStoreManager

public interface StoreManager

Interface to be implemented by data store mechanisms to interact with this JDO runtime.

Method Summary
`void` | `begin()` Begin a data store transaction.
`void` | `beginOptimistic()` Notification that an optimistic transaction has started.
`void` | `commit()` Commit the current data store transaction.
`java.lang.Object` | `copyDataStoreId(java.lang.Object oid, com.solarmetric.rd.kodo.meta.ClassMetaData meta)` Copy the given object id value.
`boolean` | `exists(java.lang.Object oid, com.solarmetric.rd.kodo.meta.ClassMetaData meta)` Verify that the given instance exists in the data store; return false if it does not.
`java.util.Collection` | `flush(java.util.Collection states)` Flush the given state manager collection to the datastore, returning a collection of user exceptions encountered during flushing.
`java.lang.Class` | `getDataStoreIdClass(com.solarmetric.rd.kodo.meta.ClassMetaData meta)` Return the class used by this StoreManager for datastore identity values.
`boolean` | `initialize(com.solarmetric.rd.kodo.runtime.StateManagerImpl sm, com.solarmetric.rd.kodo.runtime.JDOState state, java.lang.Object connection)` Initialize the given StateManager.
`void` | `load(com.solarmetric.rd.kodo.runtime.StateManagerImpl sm, int field, java.lang.Object connection)` Load the given StateManager.
`java.lang.Object` | `newDataStoreId(com.solarmetric.rd.kodo.meta.ClassMetaData meta)` Create a new unique datastore identity for the given type.
`java.lang.Object` | `newDataStoreId(java.lang.String str, com.solarmetric.rd.kodo.meta.ClassMetaData meta)` Create a new unique datastore identity for the given type from the given string.
`javax.jdo.Extent` | `newExtent(com.solarmetric.rd.kodo.meta.ClassMetaData meta, boolean subclasses)` Return an extent of the given candidate class, optionally including subclasses.
`javax.jdo.Query` | `newQuery(java.lang.String language, java.lang.Object template)` Return a query implementation suitable for this runtime.
`void` | `rollback()` Rollback the current data store transaction.
`void` | `setPersistenceManager(com.solarmetric.rd.kodo.runtime.PersistenceManagerImpl pm)` Set a reference to the corresponding PersistenceManager.
`boolean` | `synchVersion(com.solarmetric.rd.kodo.runtime.StateManagerImpl sm, java.lang.Object connection)` Update the version information in the given state manager to the version stored in the data store.

Method Detail

### setPersistenceManager

    public void setPersistenceManager(com.solarmetric.rd.kodo.runtime.PersistenceManagerImpl pm)

  Set a reference to the corresponding PersistenceManager. This method will be called before the StoreManager is used.

### beginOptimistic

    public void beginOptimistic()

  Notification that an optimistic transaction has started. This method does not replace the `begin()` method, which will still be called when a true data store transaction should begin.

### begin

    public void begin()

  Begin a data store transaction. If optimistic transactions are in use, this method will only be called when the user is ready to commit the transaction. At this time, the PersistenceManager will call this begin method, will store all modified data, and will call the commit method in succession, minimizing the length of the actual data store transaction. In this case, it is possible that the optimistic transaction does not have the latest versions of all instances (i.e. another transaction has modified the same instances and committed since the optimistic transaction started). On commit, an exception must be thrown on any attempt to overwrite data for an instance with an older version.

### commit

    public void commit()

  Commit the current data store transaction.

### rollback

    public void rollback()

  Rollback the current data store transaction.

### exists

    public boolean exists(java.lang.Object oid,
                          com.solarmetric.rd.kodo.meta.ClassMetaData meta)

  Verify that the given instance exists in the data store; return false if it does not.

### synchVersion

    public boolean synchVersion(com.solarmetric.rd.kodo.runtime.StateManagerImpl sm,
                                java.lang.Object connection)

  Update the version information in the given state manager to the version stored in the data store.

  Parameters:
    `sm` - the instance to check
    `connection` - the current connection information, or null if not given to the calling method of the persistence manager
  Returns:
    true if the instance is up-to-date, false otherwise

### initialize

    public boolean initialize(com.solarmetric.rd.kodo.runtime.StateManagerImpl sm,
                              com.solarmetric.rd.kodo.runtime.JDOState state,
                              java.lang.Object connection)

  Initialize the given StateManager. The `oid` of the StateManager will be set, and the `meta` field of the StateManager will be set to the class of the instance to load, or possibly one of its superclasses. Initialization involves first calling the `StateManagerImpl.initialize(javax.jdo.spi.PersistenceCapable, com.solarmetric.rd.kodo.runtime.JDOState)` method with a new instance of the correct type constructed with the `JDOImplHelper#newInstance(Class,StateManager,Object)` method (this will reset the `meta` field of the StateManager if the actual type was a subclass), then possibly loading fields if if desired. If this method is called during a data store transaction, the instance's database record should be locked. Version information can be loaded if desired through the `StateManagerImpl.setVersion(java.lang.Object)` method.

  Parameters:
    `sm` - the instance to initialize
    `state` - the lifecycle state to initialize the state manager with
    `connection` - the current connection information, or null if not given to the calling method of the persistence manager
  Returns:
    true if the matching instance exists in the data store, false otherwise

### load

    public void load(com.solarmetric.rd.kodo.runtime.StateManagerImpl sm,
                     int field,
                     java.lang.Object connection)

  Load the given StateManager. Note that any collection or map types loaded into the StateManager will be proxied with the correct type; therefore the StoreManager does not have to load the same concrete collection/map types as the instance declares. However, array types must be consistent with the array type stored by the PersistenceCapable instance. If this method is called during a data store transaction, the instance should be locked. If the given state manager does not have its version set already, version information can be loaded if desired through the `StateManagerImpl.setVersion(java.lang.Object)` method.

  Parameters:
    `sm` - the instance to load
    `field` - the field to load; the field corrsponding to the metadata field at the given absolute index should be loaded; additional fields can be loaded if desired; attempting to load an additional field that has been dirtied will cause the load to be ignored
    `connection` - the current connection information, or null if not given to the calling method of the persistence manager

### flush

    public java.util.Collection flush(java.util.Collection states)

  Flush the given state manager collection to the datastore, returning a collection of user exceptions encountered during flushing. The given state collection may include states that do not require data store action, such as persistent-clean instances. For datastore updates and inserts, the dirty fields of each state should be flushed. Datastore version information should be updated during flush, and the state manager's version indicator updated through the `StateManagerImpl.setNextVersion(java.lang.Object)` method. The current version will roll over to this next version upon successful commit.

### getDataStoreIdClass

    public java.lang.Class getDataStoreIdClass(com.solarmetric.rd.kodo.meta.ClassMetaData meta)

  Return the class used by this StoreManager for datastore identity values.

### copyDataStoreId

    public java.lang.Object copyDataStoreId(java.lang.Object oid,
                                            com.solarmetric.rd.kodo.meta.ClassMetaData meta)

  Copy the given object id value.

### newDataStoreId

    public java.lang.Object newDataStoreId(com.solarmetric.rd.kodo.meta.ClassMetaData meta)

  Create a new unique datastore identity for the given type.

### newDataStoreId

    public java.lang.Object newDataStoreId(java.lang.String str,
                                           com.solarmetric.rd.kodo.meta.ClassMetaData meta)

  Create a new unique datastore identity for the given type from the given string.

### newExtent

    public javax.jdo.Extent newExtent(com.solarmetric.rd.kodo.meta.ClassMetaData meta,
                                      boolean subclasses)

  Return an extent of the given candidate class, optionally including subclasses. If the extent is iterated within a data store transaction, returned instances should be locked.

### newQuery

    public javax.jdo.Query newQuery(java.lang.String language,
                                    java.lang.Object template)

  Return a query implementation suitable for this runtime. If the query is iterated within a data store transaction, returned instances should be locked.

  Parameters:
    `language` - the query language; implementations are only required to support `javax.jdo.query.JDOQL`
    `template` - a template query instance also from this StoreManager; this instance may be null; if not * null, the filter, variables, parameters, imports, and candidate class should be copied from the template to the returned Query instance

Overview | Package | Class | Tree | Deprecated | Index | Help
| SolarMetric Kodo JDO 2.5.0 Reverse Schema Tool
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

Copyright 2001,2002,2003 SolarMetric, Inc. All Rights Reserved.